
/* Portions Copyright (c) 1995,1996,1997 by Trusted Information Systems, Inc.
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND TRUSTED INFORMATION SYSTEMS DISCLAIMS
 * ALL WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL TRUSTED INFORMATION 
 * SYSTEMS BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR
 * PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS
 * ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
 * SOFTWARE.
 *
 *
 * Trusted Information Systems, Inc. has received approval from the
 * United States Government for export and reexport of TIS/DNSSEC
 * software from the United States of America under the provisions of
 * the Export Administration Regulations (EAR) General Software Note
 * (GSN) license exception for mass market software.  Under the
 * provisions of this license, this software may be exported or
 * reexported to all destinations except for the embargoed countries of
 * Cuba, Iran, Iraq, Libya, North Korea, Sudan and Syria.  Any export
 * or reexport of TIS/DNSSEC software to the embargoed countries
 * requires additional, specific licensing approval from the United
 * States Government. 
 */




#include <stdio.h> 

unsigned char bits[]= { 0x80, 0x40, 0x20, 0x10, 0x08, 0x04, 0x02, 0x01};

main()
{
  unsigned char out_str[700], str[500];
  int out, i,in, j;
  unsigned int sum;
  memset(out_str, 0, sizeof( out_str));
  while( fgets(str, sizeof(str),stdin) != NULL ) {
/*    printf("%s\n",str); */
    printf("\n");
    sum = 0;
    out = res_decode64(str, out_str,strlen(str)-1);
/*    for( i = 0; i < out; i++) {
      for( j=0; j < 8; j++) 
	if ( bits[j] & out_str[i]) printf("1");
	else printf("0");
      if( i % 8 == 7) printf("\n");
      else printf(" ");
    }
    printf("\n"); */
    for( i = 0; i < out; i++) {
      printf( "%2.2x ", out_str[i]);
      if( (i %24) == 23) printf("\n");
    }
    for( i = 0 ; i < out; i+=4) 
      sum += *(unsigned int *) &out_str[i];

    printf("\n%d ==> %d sum = %d %x\n\n",strlen(str), out,sum, sum);
/*    in  = res_encode16(out_str, out, str, sizeof(str));
    printf( "%s\n", str); */
  }
}
      
